---
title: Document.getElementsByClassName()
slug: Web/API/Document/getElementsByClassName
tags:
  - API
  - DOM
  - DOM Element Methods
  - Gecko
  - HTML5
  - Method
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>getElementsByClassName</code></strong> method of {{domxref("Document")}} interface <span class="seoSummary">returns an array-like object of all child elements which have all of the given class name(s).</span> When called on the {{domxref("document")}} object, the complete document is searched, including the root node. You may also call {{domxref("Element.getElementsByClassName", "getElementsByClassName()")}} on any element; it will return only elements which are descendants of the specified root element with the given class name(s).</p>

<div class="notecard note">
<p>Warning: This is a live {{domxref("HTMLCollection")}}. Changes in the DOM will reflect in the array as the changes occur. If an element selected by this array no longer qualifies for the selector, it will automatically be removed. Be aware of this for iteration purposes.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>elements</var> = document.getElementsByClassName(<var>names</var>); // or:
var <var>elements</var> = <var>rootElement</var>.getElementsByClassName(<var>names</var>);</pre>

<ul>
 <li><var>elements</var> is a live {{domxref("HTMLCollection")}} of found elements.</li>
 <li><var>names</var> is a string representing the class name(s) to match; multiple class names are separated by whitespace</li>
 <li>{{domxref("Element.getElementsByClassName", "getElementsByClassName")}} can be called on any element, not only on the {{domxref("document")}}. The element on which it is called will be used as the root of the search.</li>
</ul>

<h2 id="Examples">Examples</h2>

<p>Get all elements that have a class of 'test':</p>

<pre class="brush: js notranslate">document.getElementsByClassName('test')</pre>

<p>Get all elements that have both the 'red' and 'test' classes:</p>

<pre class="brush: js notranslate">document.getElementsByClassName('red test')</pre>

<p>Get all elements that have a class of 'test', inside of an element that has the ID of 'main':</p>

<pre class="brush: js notranslate">document.getElementById('main').getElementsByClassName('test')</pre>

<p>Get the first element with a class of 'test', or <code>undefined</code> if there is no matching element:</p>

<pre class="brush: js notranslate">document.getElementsByClassName('test')[0]</pre>

<p>We can also use methods of Array.prototype on any {{domxref("HTMLCollection")}} by passing the <code>HTMLCollection</code> as the method's <var>this</var> value. Here we'll find all div elements that have a class of 'test':</p>

<pre class="brush: js notranslate">var testElements = document.getElementsByClassName('test');
var testDivs = Array.prototype.filter.call(testElements, function(testElement){
  return testElement.nodeName === 'DIV';
});</pre>

<h3 id="Get_the_first_element_whose_class_is_test">Get the first element whose class is 'test'</h3>

<p>This is the most commonly used method of operation.</p>

<pre class="notranslate">&lt;html&gt;
&lt;body&gt;
    &lt;div id="parent-id"&gt;
        &lt;p&gt;hello world 1&lt;/p&gt;
        &lt;p class="test"&gt;hello world 2&lt;/p&gt;
        &lt;p&gt;hello world 3&lt;/p&gt;
        &lt;p&gt;hello world 4&lt;/p&gt;
    &lt;/div&gt;

    &lt;script&gt;
        var parentDOM = document.getElementById("parent-id");

        var test = parentDOM.getElementsByClassName("test"); // a list of matching elements, *not* the element itself
        console.log(test); //HTMLCollection[1]

        var testTarget = parentDOM.getElementsByClassName("test")[0]; // the first element, as we wanted
        console.log(testTarget); //&lt;p class="test"&gt;hello world 2&lt;/p&gt;
    &lt;/script&gt;
&lt;/body&gt;
&lt;/html&gt;</pre>

<h3 id="Multiple_Classes_Example">Multiple Classes Example</h3>

<p><code>document.getElementsByClassName</code> works very similarly to <code>document.querySelector</code> and <code>document.querySelectorAll</code>. Only elements with ALL of the classNames specified are selected.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;span class="orange fruit"&gt;Orange Fruit&lt;/span&gt;
&lt;span class="orange juice"&gt;Orange Juice&lt;/span&gt;
&lt;span class="apple juice"&gt;Apple Juice&lt;/span&gt;
&lt;span class="foo bar"&gt;Something Random&lt;/span&gt;
&lt;textarea id="resultArea" style="width:98%;height:7em"&gt;&lt;/textarea&gt;</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">// getElementsByClassName only selects elements that have both given classes
var allOrangeJuiceByClass = document.getElementsByClassName('orange juice');
var result = "document.getElementsByClassName('orange juice')";
for (var i=0, len=allOrangeJuiceByClass.length|0; i&lt;len; i=i+1|0) {
    result += "\n  " + allOrangeJuiceByClass[i].textContent;
}

// querySelector only selects full complete matches
var allOrangeJuiceQuery = document.querySelectorAll('.orange.juice');
result += "\n\ndocument.querySelectorAll('.orange.juice')";
for (var i=0, len=allOrangeJuiceQuery.length|0; i&lt;len; i=i+1|0) {
    result += "\n  " + allOrangeJuiceQuery[i].textContent;
}

document.getElementById("resultArea").value = result;</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Multiple_Classes_Example', '100%', 200)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-document-getelementsbyclassname', 'document.getElementsByClassName')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.getElementsByClassName")}}</p>
